
ChiliProject - Feature # 146: Allow underscores in project identifiers

Status: Closed Priority: Normal
Author: Derek Montgomery Category:
Created: 2011-02-04 Assignee: Felix Schäfer
Updated: 2011-02-22 Due date:
Remote issue URL:
Affected version:
Description: If there is no specific reason to disallow underscores, can you please allow them to be used in project 

identifiers??
(Category Projects)

Associated revisions
2011-02-22 09:50 pm - Felix SchÃ¤fer 
Allow underscores in project identifiers. #146

History
2011-02-04 08:30 pm - Derek Montgomery
- Target version set to 1.1.0 â€” Bell

- File CP_underscore_in_identifier.patch added

- Assignee set to Eric Davis

- Status changed from Open to Ready for review

Added patch file (thanks thegcat)

2011-02-04 08:50 pm - Holger Just
We use that patch in different production sites for some time now. No issues whatsoever. I vote go.

2011-02-04 08:52 pm - Holger Just
- Target version deleted (1.1.0 â€” Bell)

- Assignee deleted (Eric Davis)

- Status changed from Ready for review to Needs more information

Oh, forgot, we still need a test for that. So I withdraw my vote until we have a test failing without the patch and passing with it.

2011-02-05 01:29 am - Eric Davis
Should we allow an identifier to start with an underscore also?

I also think there is a locale string that needs to be changed, identifier has a text hint:

<pre>
  text_project_identifier_info: 'Only lower case letters (a-z), numbers and dashes are allowed.<br />Once saved, the identifier can not be changed.'
</pre>

Holger: should we set the Status to Open? Needs more information is used if the request isn't clear.
2011-02-05 01:41 am - Holger Just
- Status changed from Needs more information to Open

Eric Davis wrote:
> Holger: should we set the Status to Open? Needs more information is used if the request isn't clear.

Probably better, yes.

2011-02-05 11:02 am - Felix Schäfer
Eric Davis wrote:
> Should we allow an identifier to start with an underscore also?

I can't think of a reason not too.

2011-02-20 05:25 pm - Felix Schäfer
- Assignee set to Felix Schäfer

Holger Just wrote:
> Oh, forgot, we still need a test for that. So I withdraw my vote until we have a test failing without the patch and passing with it.

I'll give it a try. Is this small enough for 1.2.0?

2011-02-20 10:35 pm - Toshi MARUYAMA
Please see.

* http://www.redmine.org/issues/6253
* http://www.redmine.org/issues/7493

2011-02-20 10:39 pm - Toshi MARUYAMA
You need to change config/routes.rb.

https://github.com/brentsowers1/redmine/blob/master/config/routes.rb#L198

2011-02-21 08:45 pm - Felix Schäfer
- Target version set to 1.1.0 â€” Bell

- Status changed from Open to Ready for review

Proposed patch:

<pre><code class="diff">diff --git a/app/models/project.rb b/app/models/project.rb
index 8315a48..eb0da23 100644
--- a/app/models/project.rb
+++ b/app/models/project.rb
@@ -75,7 +75,7 @@ class Project < ActiveRecord::Base
   validates_length_of :homepage, :maximum => 255
   validates_length_of :identifier, :in => 1..IDENTIFIER_MAX_LENGTH
   # donwcase letters, digits, dashes but not digits only
-  validates_format_of :identifier, :with => /^(?!\d+$)[a-z0-9\-]*$/, :if => Proc.new { |p| p.identifier_changed? }
+  validates_format_of :identifier, :with => /^(?!\d+$)[a-z0-9\-_]*$/, :if => Proc.new { |p| p.identifier_changed? }
   # reserved words
   validates_exclusion_of :identifier, :in => %w( new )
 
diff --git a/test/unit/project_test.rb b/test/unit/project_test.rb
index 8eb79fd..936008b 100644
--- a/test/unit/project_test.rb
+++ b/test/unit/project_test.rb
@@ -101,6 +101,7 @@ class ProjectTest < ActiveSupport::TestCase
     to_test = {"abc" => true,
                "ab12" => true,
                "ab-12" => true,
+               "ab_12" => true,
                "12" => false,
                "new" => false}
                </code></pre>

As this doesn't break backwards compatibility, I'd even put it in 1.1, feel free to reschedule if you don't agree.

2011-02-22 07:18 pm - Eric Davis
Felix:

Need to change the i18n strings too. See "note 4":https://www.chiliproject.org/issues/146#note-4 above

2011-02-22 08:52 pm - Felix Schäfer
- Status changed from Ready for review to Closed

I didn't want to spam with the locale changes :-) Committed in commit:9ed2d8ed77906c21f6df8331008aad2adcf23148.

Files
CP_underscore_in_identifier.patch 695 Bytes 2011-02-04 Derek Montgomery
